# coding: utf-8

"""
    Kinde Management API

     Provides endpoints to manage your Kinde Businesses.  ## Intro  ## How to use  1. [Set up and authorize a machine-to-machine (M2M) application](https://docs.kinde.com/developer-tools/kinde-api/connect-to-kinde-api/).  2. [Generate a test access token](https://docs.kinde.com/developer-tools/kinde-api/access-token-for-api/)  3. Test request any endpoint using the test token 

    The version of the OpenAPI document: 1
    Contact: support@kinde.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from kinde_sdk.management.models.create_connection_request_options_one_of import CreateConnectionRequestOptionsOneOf
from kinde_sdk.management.models.create_connection_request_options_one_of1 import CreateConnectionRequestOptionsOneOf1
from kinde_sdk.management.models.create_connection_request_options_one_of2 import CreateConnectionRequestOptionsOneOf2
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CREATECONNECTIONREQUESTOPTIONS_ONE_OF_SCHEMAS = ["CreateConnectionRequestOptionsOneOf", "CreateConnectionRequestOptionsOneOf1", "CreateConnectionRequestOptionsOneOf2"]

class CreateConnectionRequestOptions(BaseModel):
    """
    CreateConnectionRequestOptions
    """
    # data type: CreateConnectionRequestOptionsOneOf
    oneof_schema_1_validator: Optional[CreateConnectionRequestOptionsOneOf] = None
    # data type: CreateConnectionRequestOptionsOneOf1
    oneof_schema_2_validator: Optional[CreateConnectionRequestOptionsOneOf1] = None
    # data type: CreateConnectionRequestOptionsOneOf2
    oneof_schema_3_validator: Optional[CreateConnectionRequestOptionsOneOf2] = None
    actual_instance: Optional[Union[CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2]] = None
    one_of_schemas: Set[str] = { "CreateConnectionRequestOptionsOneOf", "CreateConnectionRequestOptionsOneOf1", "CreateConnectionRequestOptionsOneOf2" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = CreateConnectionRequestOptions.model_construct()
        error_messages = []
        match = 0
        # validate data type: CreateConnectionRequestOptionsOneOf
        if not isinstance(v, CreateConnectionRequestOptionsOneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateConnectionRequestOptionsOneOf`")
        else:
            match += 1
        # validate data type: CreateConnectionRequestOptionsOneOf1
        if not isinstance(v, CreateConnectionRequestOptionsOneOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateConnectionRequestOptionsOneOf1`")
        else:
            match += 1
        # validate data type: CreateConnectionRequestOptionsOneOf2
        if not isinstance(v, CreateConnectionRequestOptionsOneOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CreateConnectionRequestOptionsOneOf2`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in CreateConnectionRequestOptions with oneOf schemas: CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in CreateConnectionRequestOptions with oneOf schemas: CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into CreateConnectionRequestOptionsOneOf
        try:
            instance.actual_instance = CreateConnectionRequestOptionsOneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CreateConnectionRequestOptionsOneOf1
        try:
            instance.actual_instance = CreateConnectionRequestOptionsOneOf1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CreateConnectionRequestOptionsOneOf2
        try:
            instance.actual_instance = CreateConnectionRequestOptionsOneOf2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into CreateConnectionRequestOptions with oneOf schemas: CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into CreateConnectionRequestOptions with oneOf schemas: CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CreateConnectionRequestOptionsOneOf, CreateConnectionRequestOptionsOneOf1, CreateConnectionRequestOptionsOneOf2]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


